#define BASE_PERIPHERAL				((uint32_t) 0x40000000)

#define OFFSET_APB1					((uint32_t) (BASE_PERIPHERAL + 0x00000000))
#define OFFSET_APB2					((uint32_t) (BASE_PERIPHERAL + 0x00010000))
#define OFFSET_AHB					((uint32_t) (BASE_PERIPHERAL + 0x00020000))





/*****************************************************************************/
/*                        	 APB1 Peripherals              					 */
/*****************************************************************************/

#define BASE_ADDRESS_TIMER_2		((uint32_t) (OFFSET_APB1 + 0x00000000))
#define BASE_ADDRESS_TIMER_3		((uint32_t) (OFFSET_APB1 + 0x00000400))
#define BASE_ADDRESS_TIMER_4		((uint32_t) (OFFSET_APB1 + 0x00000800))
#define BASE_ADDRESS_RTC			((uint32_t) (OFFSET_APB1 + 0x00002800))
#define BASE_ADDRESS_WWDG			((uint32_t) (OFFSET_APB1 + 0x00002C00))
#define BASE_ADDRESS_IWDG			((uint32_t) (OFFSET_APB1 + 0x00003000))
#define BASE_ADDRESS_SPI_2			((uint32_t) (OFFSET_APB1 + 0x00003800))
#define BASE_ADDRESS_USART_2		((uint32_t) (OFFSET_APB1 + 0x00004400))
#define BASE_ADDRESS_USART_3		((uint32_t) (OFFSET_APB1 + 0x00004800))
#define BASE_ADDRESS_I2C_1			((uint32_t) (OFFSET_APB1 + 0x00005400))
#define BASE_ADDRESS_I2C_2			((uint32_t) (OFFSET_APB1 + 0x00005800))
#define BASE_ADDRESS_CAN_1			((uint32_t) (OFFSET_APB1 + 0x00006400))
#define BASE_ADDRESS_CAN_2			((uint32_t) (OFFSET_APB1 + 0x00006800))
#define BASE_ADDRESS_BKP			((uint32_t) (OFFSET_APB1 + 0x00006C00))
#define BASE_ADDRESS_PWR			((uint32_t) (OFFSET_APB1 + 0x00007000))





/*****************************************************************************/
/*                        	 APB2 Peripherals              					 */
/*****************************************************************************/

#define BASE_ADDRESS_AFIO			((uint32_t) (OFFSET_APB2 + 0x00000000))
#define BASE_ADDRESS_EXTI			((uint32_t) (OFFSET_APB2 + 0x00000400))
#define BASE_ADDRESS_GPIO_A			((uint32_t) (OFFSET_APB2 + 0x00000800))
#define BASE_ADDRESS_GPIO_B			((uint32_t) (OFFSET_APB2 + 0x00000C00))
#define BASE_ADDRESS_ADC_1			((uint32_t) (OFFSET_APB2 + 0x00002400))
#define BASE_ADDRESS_ADC_2			((uint32_t) (OFFSET_APB2 + 0x00002800))
#define BASE_ADDRESS_TIMER_1		((uint32_t) (OFFSET_APB2 + 0x00002C00))
#define BASE_ADDRESS_SPI_1			((uint32_t) (OFFSET_APB2 + 0x00003000))
#define BASE_ADDRESS_USART_1		((uint32_t) (OFFSET_APB2 + 0x00003800))




/*****************************************************************************/
/*                        	 AHB Peripherals              					 */
/*****************************************************************************/

#define BASE_ADDRESS_DMA_1			((uint32_t) (OFFSET_AHB + 0x00000000))
#define BASE_ADDRESS_DMA_2			((uint32_t) (OFFSET_AHB + 0x00000400))
#define BASE_ADDRESS_RCC			((uint32_t) (OFFSET_AHB + 0x00001000))





/*****************************************************************************/
/*                       Register Definitions              					 */
/*****************************************************************************/



/* Timer 2 */

#define TIMER_2_CR1					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x00))
#define TIMER_2_CR2					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x04))
#define TIMER_2_SMCR				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x08))
#define TIMER_2_DIER				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x0C))
#define TIMER_2_SR					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x10))
#define TIMER_2_EGR					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x14))
#define TIMER_2_CCMR1				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x18))
#define TIMER_2_CCMR2				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x1C))
#define TIMER_2_CCER				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x20))
#define TIMER_2_CNT					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x24))
#define TIMER_2_PSC					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x28))
#define TIMER_2_ARR					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x2C))
#define TIMER_2_CCR1				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x34))
#define TIMER_2_CCR2				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x38))
#define TIMER_2_CCR3				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x3C))
#define TIMER_2_CCR4				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x40))
#define TIMER_2_DCR					*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x48))
#define TIMER_2_DMAR				*((uint32_t*) (BASE_ADDRESS_TIMER_2 + 0x4C))



/* Timer 3 */

#define TIMER_3_CR1					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x00))
#define TIMER_3_CR2					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x04))
#define TIMER_3_SMCR				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x08))
#define TIMER_3_DIER				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x0C))
#define TIMER_3_SR					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x10))
#define TIMER_3_EGR					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x14))
#define TIMER_3_CCMR1				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x18))
#define TIMER_3_CCMR2				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x1C))
#define TIMER_3_CCER				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x20))
#define TIMER_3_CNT					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x24))
#define TIMER_3_PSC					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x28))
#define TIMER_3_ARR					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x2C))
#define TIMER_3_CCR1				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x34))
#define TIMER_3_CCR2				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x38))
#define TIMER_3_CCR3				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x3C))
#define TIMER_3_CCR4				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x40))
#define TIMER_3_DCR					*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x48))
#define TIMER_3_DMAR				*((uint32_t*) (BASE_ADDRESS_TIMER_3 + 0x4C))



/* Timer 4 */

#define TIMER_4_CR1					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x00))
#define TIMER_4_CR2					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x04))
#define TIMER_4_SMCR				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x08))
#define TIMER_4_DIER				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x0C))
#define TIMER_4_SR					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x10))
#define TIMER_4_EGR					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x14))
#define TIMER_4_CCMR1				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x18))
#define TIMER_4_CCMR2				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x1C))
#define TIMER_4_CCER				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x20))
#define TIMER_4_CNT					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x24))
#define TIMER_4_PSC					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x28))
#define TIMER_4_ARR					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x2C))
#define TIMER_4_CCR1				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x34))
#define TIMER_4_CCR2				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x38))
#define TIMER_4_CCR3				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x3C))
#define TIMER_4_CCR4				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x40))
#define TIMER_4_DCR					*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x48))
#define TIMER_4_DMAR				*((uint32_t*) (BASE_ADDRESS_TIMER_4 + 0x4C))



/* RTC */

#define RTC_CRH						*((uint32_t*) (BASE_ADDRESS_RTC + 0x00))
#define RTC_CRL						*((uint32_t*) (BASE_ADDRESS_RTC + 0x04))
#define RTC_PRLH					*((uint32_t*) (BASE_ADDRESS_RTC + 0x08))
#define RTC_PRLL					*((uint32_t*) (BASE_ADDRESS_RTC + 0x0C))
#define RTC_DIVH					*((uint32_t*) (BASE_ADDRESS_RTC + 0x10))
#define RTC_DIVL					*((uint32_t*) (BASE_ADDRESS_RTC + 0x14))
#define RTC_CNTH					*((uint32_t*) (BASE_ADDRESS_RTC + 0x18))
#define RTC_CNTL					*((uint32_t*) (BASE_ADDRESS_RTC + 0x1C))
#define RTC_ALRH					*((uint32_t*) (BASE_ADDRESS_RTC + 0x20))
#define RTC_ALRL					*((uint32_t*) (BASE_ADDRESS_RTC + 0x24))



/* WWDG */

#define WWDG_CR						*((uint32_t*) (BASE_ADDRESS_WWDG + 0x00))
#define WWDG_CFR					*((uint32_t*) (BASE_ADDRESS_WWDG + 0x04))
#define WWDG_SR						*((uint32_t*) (BASE_ADDRESS_WWDG + 0x08))



/* IWDG */

#define IWDG_KR						*((uint32_t*) (BASE_ADDRESS_IWDG + 0x00))
#define IWDG_PR						*((uint32_t*) (BASE_ADDRESS_IWDG + 0x04))
#define IWDG_RLR					*((uint32_t*) (BASE_ADDRESS_IWDG + 0x08))
#define IWDG_SR						*((uint32_t*) (BASE_ADDRESS_IWDG + 0x0C))



/* SPI 2 */

#define SPI_2_CR1					*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x00))
#define SPI_2_CR2					*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x04))
#define SPI_2_SR					*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x08))
#define SPI_2_DR					*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x0C))
#define SPI_2_CRCPR					*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x10))
#define SPI_2_RXCRCR				*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x14))
#define SPI_2_TXCRCR				*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x18))
#define SPI_2_I2SCFGR				*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x1C))
#define SPI_2_I2SPR					*((uint32_t*) (BASE_ADDRESS_SPI_2 + 0x20))



/* USART 2 */

#define USART_2_SR					*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x00))
#define USART_2_DR					*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x04))
#define USART_2_BRR					*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x08))
#define USART_2_CR1					*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x0C))
#define USART_2_CR2					*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x10))
#define USART_2_CR3					*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x14))
#define USART_2_GTPR				*((uint32_t*) (BASE_ADDRESS_USART_2 + 0x18))



/* USART 3 */

#define USART_3_SR					*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x00))
#define USART_3_DR					*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x04))
#define USART_3_BRR					*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x08))
#define USART_3_CR1					*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x0C))
#define USART_3_CR2					*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x10))
#define USART_3_CR3					*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x14))
#define USART_3_GTPR				*((uint32_t*) (BASE_ADDRESS_USART_3 + 0x18))



/* I2C 1 */

#define I2C_1_CR1					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x00))
#define I2C_1_CR2					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x04))
#define I2C_1_OAR1					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x08))
#define I2C_1_OAR2					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x0C))
#define I2C_1_DR					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x10))
#define I2C_1_SR1					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x14))
#define I2C_1_SR2					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x18))
#define I2C_1_CCR					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x1C))
#define I2C_1_TRISE					*((uint32_t*) (BASE_ADDRESS_I2C_1 + 0x20))



/* I2C 2 */

#define I2C_2_CR1					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x00))
#define I2C_2_CR2					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x04))
#define I2C_2_OAR1					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x08))
#define I2C_2_OAR2					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x0C))
#define I2C_2_DR					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x10))
#define I2C_2_SR1					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x14))
#define I2C_2_SR2					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x18))
#define I2C_2_CCR					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x1C))
#define I2C_2_TRISE					*((uint32_t*) (BASE_ADDRESS_I2C_2 + 0x20))




/* CAN */

#define CAN_MCR						*((uint32_t*) (BASE_ADDRESS_CAN + 0x00))
#define CAN_MSR						*((uint32_t*) (BASE_ADDRESS_CAN + 0x04))
#define CAN_TSR						*((uint32_t*) (BASE_ADDRESS_CAN + 0x08))
#define CAN_RF0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x0C))
#define CAN_RF1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x10))
#define CAN_IER						*((uint32_t*) (BASE_ADDRESS_CAN + 0x14))
#define CAN_ESR						*((uint32_t*) (BASE_ADDRESS_CAN + 0x18))
#define CAN_BTR						*((uint32_t*) (BASE_ADDRESS_CAN + 0x1C))

#define CAN_TI0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x180))
#define CAN_TDT0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x184))
#define CAN_TDL0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x188))
#define CAN_TDH0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x18C))
#define CAN_TI1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x190))
#define CAN_TDT1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x194))
#define CAN_TDL1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x198))
#define CAN_TDH1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x19C))
#define CAN_TI2R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1A0))
#define CAN_TDT2R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1A4))
#define CAN_TDL2R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1A8))
#define CAN_TDH2R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1AC))
#define CAN_RI0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1B0))
#define CAN_RDT0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1B4))
#define CAN_RDL0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1B8))
#define CAN_RDH0R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1BC))
#define CAN_RI1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1C0))
#define CAN_RDT1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1C4))
#define CAN_RDL1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1C8))
#define CAN_RDH1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x1CC))
#define CAN_FMR						*((uint32_t*) (BASE_ADDRESS_CAN + 0x200))
#define CAN_FM1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x204))
#define CAN_FS1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x20C))
#define CAN_FFA1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x214))
#define CAN_FA1R					*((uint32_t*) (BASE_ADDRESS_CAN + 0x21C))
#define CAN_F0R1					*((uint32_t*) (BASE_ADDRESS_CAN + 0x240))
#define CAN_F0R2					*((uint32_t*) (BASE_ADDRESS_CAN + 0x244))
#define CAN_F1R1					*((uint32_t*) (BASE_ADDRESS_CAN + 0x248))
#define CAN_F1R2					*((uint32_t*) (BASE_ADDRESS_CAN + 0x24C))
#define CAN_F27R1					*((uint32_t*) (BASE_ADDRESS_CAN + 0x318))
#define CAN_F27R2					*((uint32_t*) (BASE_ADDRESS_CAN + 0x31C))




/* Backup Register */

#define BKP_DR1						*((uint32_t*) (BASE_ADDRESS_BKP + 0x04))
#define BKP_DR2						*((uint32_t*) (BASE_ADDRESS_BKP + 0x08))
#define BKP_DR3						*((uint32_t*) (BASE_ADDRESS_BKP + 0x0C))
#define BKP_DR4						*((uint32_t*) (BASE_ADDRESS_BKP + 0x10))
#define BKP_DR5						*((uint32_t*) (BASE_ADDRESS_BKP + 0x14))
#define BKP_DR6						*((uint32_t*) (BASE_ADDRESS_BKP + 0x18))
#define BKP_DR7						*((uint32_t*) (BASE_ADDRESS_BKP + 0x1C))
#define BKP_DR8						*((uint32_t*) (BASE_ADDRESS_BKP + 0x20))
#define BKP_DR9						*((uint32_t*) (BASE_ADDRESS_BKP + 0x24))
#define BKP_DR10					*((uint32_t*) (BASE_ADDRESS_BKP + 0x28))
#define BKP_RTCCR					*((uint32_t*) (BASE_ADDRESS_BKP + 0x2C))
#define BKP_CR						*((uint32_t*) (BASE_ADDRESS_BKP + 0x30))
#define BKP_CSR						*((uint32_t*) (BASE_ADDRESS_BKP + 0x34))
#define BKP_DR11					*((uint32_t*) (BASE_ADDRESS_BKP + 0x40))
#define BKP_DR12					*((uint32_t*) (BASE_ADDRESS_BKP + 0x44))
#define BKP_DR13					*((uint32_t*) (BASE_ADDRESS_BKP + 0x48))
#define BKP_DR14					*((uint32_t*) (BASE_ADDRESS_BKP + 0x4C))
#define BKP_DR15					*((uint32_t*) (BASE_ADDRESS_BKP + 0x50))
#define BKP_DR16					*((uint32_t*) (BASE_ADDRESS_BKP + 0x54))
#define BKP_DR17					*((uint32_t*) (BASE_ADDRESS_BKP + 0x58))
#define BKP_DR18					*((uint32_t*) (BASE_ADDRESS_BKP + 0x5C))
#define BKP_DR19					*((uint32_t*) (BASE_ADDRESS_BKP + 0x60))
#define BKP_DR20					*((uint32_t*) (BASE_ADDRESS_BKP + 0x64))
#define BKP_DR21					*((uint32_t*) (BASE_ADDRESS_BKP + 0x68))
#define BKP_DR22					*((uint32_t*) (BASE_ADDRESS_BKP + 0x6C))
#define BKP_DR23					*((uint32_t*) (BASE_ADDRESS_BKP + 0x70))
#define BKP_DR24					*((uint32_t*) (BASE_ADDRESS_BKP + 0x74))
#define BKP_DR25					*((uint32_t*) (BASE_ADDRESS_BKP + 0x78))
#define BKP_DR26					*((uint32_t*) (BASE_ADDRESS_BKP + 0x7C))
#define BKP_DR27					*((uint32_t*) (BASE_ADDRESS_BKP + 0x80))
#define BKP_DR28					*((uint32_t*) (BASE_ADDRESS_BKP + 0x84))
#define BKP_DR29					*((uint32_t*) (BASE_ADDRESS_BKP + 0x88))
#define BKP_DR30					*((uint32_t*) (BASE_ADDRESS_BKP + 0x8C))
#define BKP_DR31					*((uint32_t*) (BASE_ADDRESS_BKP + 0x90))
#define BKP_DR32					*((uint32_t*) (BASE_ADDRESS_BKP + 0x94))
#define BKP_DR33					*((uint32_t*) (BASE_ADDRESS_BKP + 0x98))
#define BKP_DR34					*((uint32_t*) (BASE_ADDRESS_BKP + 0x9C))
#define BKP_DR35					*((uint32_t*) (BASE_ADDRESS_BKP + 0xA0))
#define BKP_DR36					*((uint32_t*) (BASE_ADDRESS_BKP + 0xA4))
#define BKP_DR37					*((uint32_t*) (BASE_ADDRESS_BKP + 0xA8))
#define BKP_DR38					*((uint32_t*) (BASE_ADDRESS_BKP + 0xAC))
#define BKP_DR39					*((uint32_t*) (BASE_ADDRESS_BKP + 0xB0))
#define BKP_DR40					*((uint32_t*) (BASE_ADDRESS_BKP + 0xB4))
#define BKP_DR41					*((uint32_t*) (BASE_ADDRESS_BKP + 0xB8))
#define BKP_DR42					*((uint32_t*) (BASE_ADDRESS_BKP + 0xBC))




/* Power */

#define PWR_CR						*((uint32_t*) (BASE_ADDRESS_PWR + 0x00))
#define PWR_CSR						*((uint32_t*) (BASE_ADDRESS_PWR + 0x04))




/* AFIO */

#define AFIO_EVCR					*((uint32_t*) (BASE_ADDRESS_AFIO + 0x00))
#define AFIO_MAPR					*((uint32_t*) (BASE_ADDRESS_AFIO + 0x04))
#define AFIO_EXTICR1				*((uint32_t*) (BASE_ADDRESS_AFIO + 0x08))
#define AFIO_EXTICR2				*((uint32_t*) (BASE_ADDRESS_AFIO + 0x0C))
#define AFIO_EXTICR3				*((uint32_t*) (BASE_ADDRESS_AFIO + 0x10))
#define AFIO_EXTICR4				*((uint32_t*) (BASE_ADDRESS_AFIO + 0x14))
#define AFIO_MAPR2					*((uint32_t*) (BASE_ADDRESS_AFIO + 0x1C))




/* EXTI */

#define EXTI_IMR					*((uint32_t*) (BASE_ADDRESS_EXTI + 0x00))
#define EXTI_EMR					*((uint32_t*) (BASE_ADDRESS_EXTI + 0x04))
#define EXTI_RTSR					*((uint32_t*) (BASE_ADDRESS_EXTI + 0x08))
#define EXTI_FTSR					*((uint32_t*) (BASE_ADDRESS_EXTI + 0x0C))
#define EXTI_SWIER					*((uint32_t*) (BASE_ADDRESS_EXTI + 0x10))
#define EXTI_PR						*((uint32_t*) (BASE_ADDRESS_EXTI + 0x14))




/* GPIO A */

#define GPIO_A_CRL					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x00))
#define GPIO_A_CRH					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x04))
#define GPIO_A_IDR					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x08))
#define GPIO_A_ODR					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x0C))
#define GPIO_A_BSRR					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x10))
#define GPIO_A_BRR					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x14))
#define GPIO_A_LCKR					*((uint32_t*) (BASE_ADDRESS_GPIO_A + 0x18))




/* GPIO B */

#define GPIO_B_CRL					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x00))
#define GPIO_B_CRH					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x04))
#define GPIO_B_IDR					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x08))
#define GPIO_B_ODR					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x0C))
#define GPIO_B_BSRR					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x10))
#define GPIO_B_BRR					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x14))
#define GPIO_B_LCKR					*((uint32_t*) (BASE_ADDRESS_GPIO_B + 0x18))




/* ADC 1 */

#define ADC_1_SR					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x00))
#define ADC_1_CR1					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x04))
#define ADC_1_CR2					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x08))
#define ADC_1_SMPR1					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x0C))
#define ADC_1_SMPR2					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x10))
#define ADC_1_JOFR1					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x14))
#define ADC_1_JOFR2					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x18))
#define ADC_1_JOFR3					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x1C))
#define ADC_1_JOFR4					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x20))
#define ADC_1_HTR					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x24))
#define ADC_1_LTR					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x28))
#define ADC_1_SQR1					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x2C))
#define ADC_1_SQR2					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x30))
#define ADC_1_SQR3					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x34))
#define ADC_1_JSQR					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x38))
#define ADC_1_JDR1					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x3C))
#define ADC_1_JDR2					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x40))
#define ADC_1_JDR3					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x44))
#define ADC_1_JDR4					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x48))
#define ADC_1_DR					*((uint32_t*) (BASE_ADDRESS_ADC_1 + 0x4C))




/* ADC 2 */

#define ADC_2_SR					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x00))
#define ADC_2_CR1					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x04))
#define ADC_2_CR2					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x08))
#define ADC_2_SMPR1					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x0C))
#define ADC_2_SMPR2					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x10))
#define ADC_2_JOFR1					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x14))
#define ADC_2_JOFR2					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x18))
#define ADC_2_JOFR3					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x1C))
#define ADC_2_JOFR4					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x20))
#define ADC_2_HTR					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x24))
#define ADC_2_LTR					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x28))
#define ADC_2_SQR1					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x2C))
#define ADC_2_SQR2					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x30))
#define ADC_2_SQR3					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x34))
#define ADC_2_JSQR					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x38))
#define ADC_2_JDR1					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x3C))
#define ADC_2_JDR2					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x40))
#define ADC_2_JDR3					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x44))
#define ADC_2_JDR4					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x48))
#define ADC_2_DR					*((uint32_t*) (BASE_ADDRESS_ADC_2 + 0x4C))




/* Timer 1 */

#define TIMER_1_CR1					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x00))
#define TIMER_1_CR2					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x04))
#define TIMER_1_SMCR				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x08))
#define TIMER_1_DIER				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x0C))
#define TIMER_1_SR					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x10))
#define TIMER_1_EGR					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x14))
#define TIMER_1_CCMR1				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x18))
#define TIMER_1_CCMR2				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x1C))
#define TIMER_1_CCER				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x20))
#define TIMER_1_CNT					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x24))
#define TIMER_1_PSC					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x28))
#define TIMER_1_ARR					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x2C))
#define TIMER_1_RCR					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x30))
#define TIMER_1_CCR1				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x34))
#define TIMER_1_CCR2				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x38))
#define TIMER_1_CCR3				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x3C))
#define TIMER_1_CCR4				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x40))
#define TIMER_1_BDTR				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x44))
#define TIMER_1_DCR					*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x48))
#define TIMER_1_DMAR				*((uint32_t*) (BASE_ADDRESS_TIMER_1 + 0x4C))




/* SPI 1 */

#define SPI_1_CR1					*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x00))
#define SPI_1_CR2					*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x04))
#define SPI_1_SR					*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x08))
#define SPI_1_DR					*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x0C))
#define SPI_1_CRCPR					*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x10))
#define SPI_1_RXCRCR				*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x14))
#define SPI_1_TXCRCR				*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x18))
#define SPI_1_I2SCFGR				*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x1C))
#define SPI_1_I2SPR					*((uint32_t*) (BASE_ADDRESS_SPI_1 + 0x20))




/* USART 1 */

#define USART1_SR					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x00))
#define USART1_DR					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x04))
#define USART1_BRR					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x08))
#define USART1_CR1					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x0C))
#define USART1_CR2					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x10))
#define USART1_CR3					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x14))
#define USART1_GTPR					*((uint32_t*) (BASE_ADDRESS_USART_1 + 0x18))




/* DMA 1 */

#define DMA_1_ISR					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x00))
#define DMA_1_IFCR					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x04))

#define DMA_1_CCR1					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x08))
#define DMA_1_CNDTR1				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x0C))
#define DMA_1_CPAR1					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x10))
#define DMA_1_CMAR1					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x14))

#define DMA_1_CCR2					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x1C))
#define DMA_1_CNDTR2				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x20))
#define DMA_1_CPAR2					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x24))
#define DMA_1_CMAR2					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x28))

#define DMA_1_CCR3					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x30))
#define DMA_1_CNDTR3				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x34))
#define DMA_1_CPAR3					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x38))
#define DMA_1_CMAR3					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x3C))

#define DMA_1_CCR4					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x44))
#define DMA_1_CNDTR4				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x48))
#define DMA_1_CPAR4					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x4C))
#define DMA_1_CMAR4					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x50))

#define DMA_1_CCR5					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x58))
#define DMA_1_CNDTR5				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x5C))
#define DMA_1_CPAR5					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x60))
#define DMA_1_CMAR5					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x64))

#define DMA_1_CCR6					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x6C))
#define DMA_1_CNDTR6				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x70))
#define DMA_1_CPAR6					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x74))
#define DMA_1_CMAR6					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x78))

#define DMA_1_CCR7					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x80))
#define DMA_1_CNDTR7				*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x84))
#define DMA_1_CPAR7					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x88))
#define DMA_1_CMAR7					*((uint32_t*) (BASE_ADDRESS_DMA_1 + 0x8C))




/* DMA 2 */

#define DMA_2_ISR					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x00))
#define DMA_2_IFCR					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x04))

#define DMA_2_CCR1					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x08))
#define DMA_2_CNDTR1				*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x0C))
#define DMA_2_CPAR1					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x10))
#define DMA_2_CMAR1					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x14))

#define DMA_2_CCR2					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x1C))
#define DMA_2_CNDTR2				*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x20))
#define DMA_2_CPAR2					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x24))
#define DMA_2_CMAR2					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x28))

#define DMA_2_CCR3					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x30))
#define DMA_2_CNDTR3				*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x34))
#define DMA_2_CPAR3					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x38))
#define DMA_2_CMAR3					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x3C))

#define DMA_2_CCR4					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x44))
#define DMA_2_CNDTR4				*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x48))
#define DMA_2_CPAR4					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x4C))
#define DMA_2_CMAR4					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x50))

#define DMA_2_CCR5					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x58))
#define DMA_2_CNDTR5				*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x5C))
#define DMA_2_CPAR5					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x60))
#define DMA_2_CMAR5					*((uint32_t*) (BASE_ADDRESS_DMA_2 + 0x64))





